    View Javadoc
    1   package org.apache.bcel.generic;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import org.apache.bcel.classfile.ConstantPool;
    58  import org.apache.bcel.classfile.ConstantUtf8;
    59  import org.apache.bcel.classfile.ConstantNameAndType;
    60  import org.apache.bcel.classfile.ConstantCP;
    61  import org.apache.bcel.classfile.*;
    62
    63  /***
    64   * Super class for the GET/PUTxxx family of instructions.
    65   *
    66   * @version $Id: FieldInstruction.java,v 1.1.1.1 2001/10/29 20:00:12 jvanzyl Exp $
    67   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    68   */
    69  public abstract class FieldInstruction extends FieldOrMethod
    70    implements TypedInstruction {
    71    /***
    72     * Empty constructor needed for the Class.newInstance() statement in
    73     * Instruction.readInstruction(). Not to be used otherwise.
    74     */
    75    FieldInstruction() {}
    76
    77    /***
    78     * @param index to constant pool
    79     */
    80    protected FieldInstruction(short opcode, int index) {
    81      super(opcode, index);
    82    }
    83
    84    /***
    85     * @return mnemonic for instruction with symbolic references resolved
    86     */
    87    public String toString(ConstantPool cp) {
    88      return org.apache.bcel.Constants.OPCODE_NAMES[opcode] + " " +
    89        cp.constantToString(index, org.apache.bcel.Constants.CONSTANT_Fieldref);
    90    }
    91
    92    /*** @return size of field (1 or 2)
    93     */
    94    protected int getFieldSize(ConstantPoolGen cpg) {
    95      return getType(cpg).getSize();
    96    }
    97
    98    /*** @return return type of referenced field
    99     */
    100   public Type getType(ConstantPoolGen cpg) {
    101     return getFieldType(cpg);
    102   }
    103
    104   /*** @return type of field
    105    */
    106   public Type getFieldType(ConstantPoolGen cpg) {
    107     return Type.getType(getSignature(cpg));
    108   }
    109
    110   /*** @return name of referenced field.
    111    */
    112   public String getFieldName(ConstantPoolGen cpg) {
    113     return getName(cpg);
    114   }
    115 }
    116

This page was automatically generated by Maven